'' shapesz.dat 4dbf8

option explicit

declare function load_palette(pal() as uinteger) as ubyte
declare function pal_index(pal() as uinteger, c as uinteger) as ubyte
declare function chop(s as string, n as ushort) as string
declare function fileExists(filename as string) as integer

function usage() as string
  return command$(0) & " [file.bmp] [file.dat]"
end function

print "TyrBShape v0.1.0 [Mindless]"

if fileExists(command$(1)) = 0 then
  print
  print usage()
  end
end if

print
print "generating shape file..."
print "source: " & chop(command(1), 80 - 9)
print "destination: " & chop(command(2), 80 - 14)

dim as uinteger pal(255)
if load_palette(pal()) then
  screen -1
  print
  print "palette.dat was not found"
  end
end if

screenres 24 * 10, 28 * 60, 24
'screenres 640, 480, 24

if bload(command$(1), 0) then
  screen 0
  print 
  print "failed to read bitmap " & command$(1)
  end
end if

dim as ubyte ptr cmp = allocate(60 * 10 * (28 * 24 + 1))
dim as uinteger b, p, cmp_size

dim as ushort x, y, v, h

for h = 0 to 59
  for v = 0 to 9
    
    dim as ushort temp = 0
    
    for y = 0 to 27
      for x = 0 to 23
        if point(v * 24 + x, h * 28 + y) <> rgb(191, 220, 191) then
          temp = 1
        end if
        if temp <> 0 then exit for
      next
      if temp <> 0 then exit for
    next
    
    if temp = 0 then
      line (v * 24, h * 28)-(v * 24 + 23, h * 28 + 27), rgb(0, 0, 0), BF
      cmp[cmp_size] = 1
      cmp_size += 1
    else
      cmp[cmp_size] = 0
      cmp_size += 1

      for y = 0 to 27
        for x = 0 to 23
          cmp[cmp_size] = pal_index(pal(), point(v * 24 + x, h * 28 + y))
          pset (v * 24 + x, h * 28 + y), pal(pal_index(pal(), point(v * 24 + x, h * 28 + y)))
          cmp_size += 1
        next
      next
    end if
    
  next
next

dim as ubyte f = freefile

if open(command$(2), for binary, access write, as #f) then
  screen 0
  print
  print "failed to write to " & command$(2)
  end
end if

put #f, , *cmp, cmp_size
close f

deallocate(cmp)

'sleep
screen 0
end

function load_palette(pal() as uinteger) as ubyte
  dim as ubyte fh = freefile
  if open("palette.dat" for binary access read as #fh) then
    if open(exepath & "\palette.dat" for binary access read as #fh) then return 1
  end if
  seek #fh, 1280 * 3 + 1
  dim as ushort i
  dim as ubyte r, g, b
  for i = 0 to 255
    get #fh, , r, 1
    get #fh, , g, 1
    get #fh, , b, 1
    pal(i) = rgb(r * 4, g * 4, b * 4)
  next
  close #fh
  return 0
end function

function pal_index(pal() as uinteger, c as uinteger) as ubyte
  dim as ushort i
  dim as ushort dif = 2 ^ 16 - 1, tdif
  dim as ubyte  di
  
  for i = 0 to 255
    if pal(i) = c then
      return i
    end if
    
    tdif = abs(clngint((c and &hff0000) shr 16) - clngint((pal(i) and &hff0000) shr 16))
    tdif += abs(clngint((c and &hff00) shr 8) - clngint((pal(i) and &hff00) shr 8))
    tdif += abs(clngint(c and &hff) - clngint(pal(i) and &hff))
    if tdif < dif then
      dif = tdif
      di = i
    end if
    
  next
  
  return di
end function

function chop(s as string, n as ushort) as string
  if len(s) < n then return s
  return left(s, 10) & "..." & right(s, n - 13)
end function

function fileExists(filename as string) as integer
  dim as integer ff = freefile
  if(open(filename for input as #ff)) then return 0
  close ff
  return -1
end function
