declare function load_palette(pal() as uinteger) as ubyte
declare function pal_index(pal() as uinteger, c as uinteger) as ubyte
declare function usage as ubyte
declare function chop(s as string, n as ushort) as string

print "tyrbshp v0.1.1 [Mindless]"
print

print "generating shp file..."
print "source: " & chop(command(1), 80 - 9)
print "destination: " & chop(command(2), 80 - 14)

screenres 228, 224, 24

if bload(command$(1), 0) then usage

dim as uinteger pal(255)
if load_palette(pal()) then
  screen -1
  print "palette.dat was not found"
  end
end if

'' process bitmap
dim as ushort off(15, 18)

dim as uinteger  c_size = 0
dim as ubyte ptr c_data = callocate(228 * 224)

dim as ubyte x, y, xa, ya
dim as ubyte cmd, tr, pi, tmp

for ya = 0 to 15
  for xa = 0 to 18
    off(ya, xa) = c_size + &h0260
    do
      tr = 0
      pi = 0
      do while point(xa * 12 + x + tr + pi, ya * 14 + y) = rgb(191, 220, 191) and x + tr + pi < 12
        pset (xa * 12 + x + tr + pi, ya * 14 + y), rgb(0, 0, 0)
        tr += 1
      loop
      do while point(xa * 12 + x + tr + pi, ya * 14 + y) <> rgb(191, 220, 191) and x + tr + pi < 12
        'pset (xa * 12 + x + tr + pi, ya * 14 + y), rgb(255, 255, 255)
        pi += 1
      loop
      
      x += tr
      
      if pi > 0 then
        c_data[c_size] = (pi shl 4) or tr
        c_size += 1
        
        tr = 0
        
        tmp = x + pi
        do until x = tmp
          c_data[c_size] = pal_index(pal(), point(xa * 12 + x, ya * 14 + y))
          pset (xa * 12 + x, ya * 14 + y), pal(c_data[c_size])
          c_size += 1
          x += 1
        loop
      end if
      
      if x = 12 then
        c_data[c_size] = tr
        c_size += 1
        x = 0
        y += 1
      end if
      
    loop while y < 14
    
    c_data[c_size] = &h0f
    c_size += 1
    
    y = 0
  next
next

'' output to file
dim as ubyte f = freefile

if open(command$(2) for binary access write as #f) then usage

for x = 0 to 15
  for y = 0 to 18
    put #f, , off(x, y)
  next
next

put #f, , *c_data, c_size
close #f

deallocate c_data

'sleep
end


function load_palette(pal() as uinteger) as ubyte
  dim as ubyte fh = freefile
  if open("palette.dat" for binary access read as #fh) then
    if open(exepath & "\palette.dat" for binary access read as #fh) then return 1
  end if
  seek #fh, 1280 * 3 + 1
  dim as ushort i
  dim as ubyte r, g, b
  for i = 0 to 255
    get #fh, , r, 1
    get #fh, , g, 1
    get #fh, , b, 1
    pal(i) = rgb(r * 4, g * 4, b * 4)
  next
  close #fh
  return 0
end function

function pal_index(pal() as uinteger, c as uinteger) as ubyte
  dim as ushort i
  dim as ushort dif = 2 ^ 16 - 1, tdif
  dim as ubyte  di
  
  for i = 0 to 255
    if pal(i) = c then
      return i
    end if

    tdif = abs(clngint((c and &hff0000) shr 16) - clngint((pal(i) and &hff0000) shr 16))
    tdif += abs(clngint((c and &hff00) shr 8) - clngint((pal(i) and &hff00) shr 8))
    tdif += abs(clngint(c and &hff) - clngint(pal(i) and &hff))
    if tdif < dif then
      dif = tdif
      di = i
    end if
    
  next
  
  return di
end function

function usage() as ubyte
  screen 0
  print command$(0) & " [file.bmp] [file.shp]"
  'sleep
  end
  return 0
end function

function chop(s as string, n as ushort) as string
  if len(s) < n then return s
  return left(s, 10) & "..." & right(s, n - 13)
end function
