declare function count_command() as ushort
declare function dec(i as ushort, n as ushort) as string
declare function chop(s as string, n as ushort) as string

declare function unpak() as ubyte
declare function pak() as ubyte

select case command$(1)
case "-u"
  unpak
case "-p"
  pak
case "-v"
  print "tyrpack 0.1.1 [Mindless]"
case else
  print "tyrpack -u packfile"
  print "tyrpack -p packfile srcfile [srcfile [...]]"
end select

end

function unpak() as ubyte
  dim as ushort i
  
  dim as ushort sections
  dim as uinteger ptr off /' offsets from beginning of file '/
  dim as ubyte ptr d /' the entire file '/

  if count_command() < 2 then
    print "nothing to unpack"
    end
  end if
  
  dim as ubyte fh = freefile
  if open(command$(2) for binary access read as #fh) then
    print "failed to read " & command$(2)
    end
  end if
  print "unpacking " & command$(2) & "..."
  get #fh, , sections
  off = allocate((sections + 1) * sizeof(uinteger))
  for i = 0 to sections - 1
    get #fh, , off[i]
  next
  off[sections] = lof(fh)
  
  d = allocate(off[sections])
  
  seek #fh, 1
  get #fh, , *d, off[sections]
  close #fh
  
  for i = 0 to sections - 1
    if open(command$(2) & "." & dec(i, 4) for binary access write as #fh) then
      print "failed to write " & command$(2)
      end
    end if
    put #fh, , d[off[i]], off[i + 1] - off[i]
    close #fh
    ''print "unpacked section " & i & " (" & off[i + 1] - off[i] & " bytes)"
    print "unpacked " & chop(command$(2) & "." & dec(i, 4), 80 - 10)
  next
  
  return 0
end function

function pak as ubyte
  dim as ushort i
  
  dim as ushort sections = count_command()
  dim as uinteger ptr off
  dim as ubyte ptr d = allocate(0)
  
  if sections < 3 then
    print "nothing to pack"
    end
  else
    sections -= 2
  end if
  
  off = allocate((sections + 1) * sizeof(uinteger))
  off[0] = sizeof(ushort) + sections * sizeof(uinteger)
  
  print "packing " & command$(2) & "..."
  
  dim as ubyte fh = freefile
  for i = 0 to sections - 1
    if open(command$(2 + 1 + i) for binary access read as #fh) then
      print "failed to read " & command$(2 + 1 + i)
      end
    end if
    off[i + 1] = off[i] + lof(fh)
    d = reallocate(d, off[i + 1])
    get #fh, , d[off[i]], lof(fh)
    close #fh
    ''print "packed section " & i & " (" & off[i + 1] - off[i] & " bytes)"
    print "packed " & chop(command$(2 + 1 + i), 80 - 8)
  next
  
  if open(command$(2) for binary access write as #fh) then
    print "failed to write " & command$(2)
  end if
  put #fh, , *d, off[sections]
  seek #fh, 1
  put #fh, , sections
  
  for i = 0 to sections - 1
    put #fh, , off[i]
  next
  
  close #fh
  
  return 0
end function


function count_command() as ushort
  dim as ushort i
  do while command$(i + 1) <> ""
    i += 1
  loop
  return i
end function

function dec(i as ushort, n as ushort) as string
  return string(n - len(str(i)), "0") & str(i)
end function

function chop(s as string, n as ushort) as string
  if len(s) < n then return s
  return left(s, 10) & "..." & right(s, n - 13)
end function
